#!/bin/bash
# SPDX-Version: 3.0
# SPDX-CreationInfo: 2025-06-17; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-ExternalRef: GIT https://git.coresecret.dev/msw/CISS.debian.installer.git
# SPDX-FileContributor: WEIDNER, Marc S.; Centurion Intelligence Consulting Agency
# SPDX-FileCopyrightText: 2024-2025; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-FileType: SOURCE
# SPDX-License-Identifier: EUPL-1.2 OR LicenseRef-CCLA-1.0
# SPDX-LicenseComment: This file is part of the CISS.debian.installer.secure framework.
# SPDX-PackageName: CISS.debian.installer
# SPDX-Security-Contact: security@coresecret.eu

guard_sourcing

#######################################
# Exiting chroot of the target system.
# Globals:
#   TARGET
#   VAR_NEED_RUN_IN_TARGET
# Arguments:
#   None
# Returns:
#   0: on success
#######################################
exiting_chroot_system() {
  ### Declare Arrays, HashMaps, and Variables.
  declare -a ary_umount=( "/sys/fs/cgroup" "/dev/hugepages" "/dev/mqueue" "/dev/shm" "/dev/pts" "/proc" "/sys" "/dev" )
  declare    var_path=""

  for var_path in "${ary_umount[@]}"; do

    umount -l "${TARGET}${var_path}" 2>/dev/null || true
    do_log "info" "file_only" "4999() Command: [umount -l ${TARGET}${var_path} 2>/dev/null || true] issued."

  done

  if [[ "${VAR_NEED_RUN_IN_TARGET:-false}" == "true" ]]; then

    umount -l "${TARGET}/run" 2>/dev/null || true
    do_log "info" "file_only" "4999() Command: [umount -l ${TARGET}/run 2>/dev/null || true] issued."

  fi

  declare -gx VAR_CHROOT_ACTIVATED="false"

  guard_dir && return 0
}
# vim: number et ts=2 sw=2 sts=2 ai tw=128 ft=sh
